<pre><?php
require_once 'basiciterator.php';

class ludi_array_access extends ludi_basic_iterator implements ArrayAccess
{
 	public function offsetExists ($offset)
 	{
 		return isset($this->_ray[$offset]);
 	}
 	
 	public function offsetGet ($offset)
 	{
 		return $this->_ray[$offset];
 	}
 	
 	public function offsetSet ($offset, $value)
 	{
 		return $this->_ray[$offset] = $value;
 	}
 	
 	public function offsetUnset ($offset)
 	{
 		unset($this->_ray[$offset]);
 	}
}


$array = array(
	'this' => 'that',
	'them' => 'us',
	0 => 'nothing',
	'one' => 1,
	'someone' => 'that guy',
);

$array_access = new ludi_array_access($array);

var_dump($array_access['this']);
var_dump($array_access['nil']);
$array_access['nothing'] = 'something';
$array_access[] = 'which';
$array_access[0] = 'empty';
echo "\n";

foreach($array_access as $key => $val)
{
	echo "{$key} => {$val}\n";
}

echo count($array_access);
echo "\n";
echo $array_access[''];
echo $array_access[null];
