<?php
define('FIRST', true);
require_once 'basiciterator.php';

$array = array(
	'zero',
	'one',
	'two',
	'three',
	'four',
	'five',
	'six',
);

$multi_array = array(
	$array,
	array(
		'this',
		'that',
	),
	array(
		'ho',
		'hum',
	),
);

echo "InifinateIterator wrapped in LimitIterator\n";

foreach($limit_infinite = new LimitIterator(new InfiniteIterator(new ludi_basic_iterator($array)), 0, 10) as $key => $val)
{
	echo "{$key} => {$val}\n";
}

var_dump(iterator_to_array($limit_infinite));
var_dump(iterator_count($limit_infinite));

echo "RegexIterator\n";

foreach(new RegexIterator(new ludi_basic_iterator($array), '/o/') as $key => $val)
{
	echo "{$key} => {$val}\n";
}

echo "RecursiveRegexIterator\n";

foreach(new RecursiveIteratorIterator(new RecursiveRegexIterator(new RecursiveArrayIterator($multi_array), '/(^Array$)|o/')) as $key => $val)
{
	echo "{$key} => {$val}\n";
}
